VehicleInspector = {};

VehicleInspector.metadata = {
	interface = " FS19 1.x",
	title = " VehicleInspector",
	notes = " Zeigt/Ändert Vehicle Informationen/Bestände und vieles mehr in einem PDA Hud an",
	author = " (by HappyLooser)",
	version = " v1.45 Beta",
	datum = " 05.11.2016",
	update = " 09.12.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};
--update *new ownFarmVehicle,lineNextTxtDistancePosX,lineDistancePosY,attachedLimit,isHorsePlayer,horseTxt,otherL=leasing,isLeasing,leasingTxtLast,horse values,new color string,xml new structures,ownPosition simple,showHelpOn/Off and input empty
--Fix Horse Lua Error, Performenc,otherSaOrFill txt,showHelpOn/off
VehicleInspector.modDir = g_currentModDirectory;
function VehicleInspector:loadMap(name)
	g_currentMission.vehicleInspector = VehicleInspector;	
	print("---loading".. tostring(VehicleInspector.metadata.title).. tostring(VehicleInspector.metadata.version).. tostring(VehicleInspector.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleInspector.settingsDir = getUserProfileAppPath().. "modsSettings/VehicleInspector/";																					
	VehicleInspector.simple = {isOn=true,rebootXml=false,showInGameMapOn=true,showInGameMapOff=true,showHelpOn=false,showHelpOff=true,allTxtBold=false,vehicleSchemaPosY=0,defaultPosX=0.01,defaultPosY=0.98,defaultLastWidth=0,defaultLastHeight=0,defaultSize=0.010,lineNextTxtDistancePosX=0.001,lineDistancePosY=0.005,
	seeField=false,seeSpeed=true,seeFillName=true,seeRealFillName=false,isFillFull=false,seeFillLevel=true,isTrain=false,seeProzent=true,ownFarmVehicle=true,seePlayerName=true,seeVehicleName=false,seeVehicleSmallName=true;isHelper=true,isPlayer=true,isBlocking=true,isFuel=false,isWater=true,
	seeVehicleTypeName=false,isDamage=false,seeLastTotalAttached=true, isHorsePlayer=true, horseWarningColor=true, seeHorseCare=true, seeHorseDayRiding=true, seeHorseTodayRiding=true, seeHorseTodayRidingMin=true, seeHorseTodayRidingSec=true, seeHorseFitness=true, seeHorseHealth=true, isLeasing=true, leasingTxtLast=true, attachedLimit=4};
	if g_currentMission.hud ~= nil and g_currentMission.hud.vehicleSchema ~= nil and g_currentMission.hud.vehicleSchema.overlay ~= nil then VehicleInspector.simple.vehicleSchemaPosY = Utils.getNoNil(g_currentMission.hud.vehicleSchema.overlay.y, VehicleInspector.simple.defaultPosY);end;
	VehicleInspector.simple.showMod = {		
		helpMenuOn=false;
		helpMenuOnAndInputEmpty=false;
		helpMenuOff=true;
		helpMenuOffAndInputEmpty=true;
		inGameMapOn=false;
		inGameMapOff=true;
	};
	VehicleInspector.simple.ownPos = {
		isOn = false;
		x = 0.005;
		y = 0.95;
		showHelpOnAutoFixX = false;
		showHelpOnAutoFixY = false;
		showHelpOnFixX = 0;
		showHelpOnFixY = 0;
		showHelpOffAutoFixX = false;
		showHelpOffAutoFixY = false;
		showHelpOffFixX = 0;
		showHelpOffFixY = 0;
		showInGameMapOnAutoFixX = false;
		showInGameMapOnAutoFixY = false;
		showInGameMapOnFixX = 0;
		showInGameMapOnFixY = 0;
		showInGameMapOffAutoFixX = false;
		showInGameMapOffAutoFixY = false;
		showInGameMapOffFixX = 0;
		showInGameMapOffFixY = 0;
		isDown = true;
		isLeft = true;
		rightLengthAutoFixX = true;
	};
	VehicleInspector.simple.txt = {		
		separator = "|";
		speed = " km";
		field = "F ";
		horse = Utils.getNoNil(g_i18n:getText("ui_horseName"), "Horsename").. " ";
		fillNameToFillLevel = " ";  --is separator
		helperS = "H";
		otherT = "O";				
		playerS = "P";				
		otherSaEmpty = "! Empty !";
		otherSa = "^";				--is separator, see better Seeds/sowing etc.
		otherSaOrFill = "?";		--is separator, Seeds/sowing or Fill is Unknown etc.
		otherW = "! Water !";
		otherD = "! Damage !";
		otherB = "! Blocking !";
		otherFuelEmpty = "! Fuel Empty !";
		otherFull = "! Full !";
		otherL = "Leasing";
		horseHealth = "Health: ";
		horseFitness = Utils.getNoNil(g_i18n:getText("ui_horseFitness"), "Fitness:").. " ";
		horseTodayRiding = "Today Riding: ";
		horseDayRiding = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding:").. " ";
		horseTodayRidingHour = "h";
		horseCare = Utils.getNoNil(g_i18n:getText("statistic_cleanliness"), "Care:").. " ";
	};
	VehicleInspector.simple.searchInvert = {"sowing", "sowingmachine", "sprayer", "fertilizer", "manure"};
	VehicleInspector.simple.color = {
		default = {1, 1, 1, 1}, --white
		playerControlled = { 0/255, 255/255, 255/255, 1 }, --ls15
		anotherPlayerControlled = { 0/255, 255/255, 255/255, 0.80 }, --ls15Disabled
		isField = { 255/255, 0/255, 255/255, 1.00 }, --mangenta
		isWater = { 0/255, 0/255, 255/255, 1 }, --darkBlue
		isDamage = { 255/255, 165/255,  0/255, 1 } ,--orange
		isBlocking = { 255/255, 0/255, 0/255, 1 }, --red
		isLeasing = { 255/255, 020/255, 147/255, 1.00 } --deepPink
	};
	VehicleInspector.simple.color.prozent = {};
	VehicleInspector.simple.color.prozent[1] = {255/255, 	255/255, 	255/255,	1.00 }; --white
	VehicleInspector.simple.color.prozent[2] = {  0/255,	255/255, 	  0/255, 	1.00 }; --green
	VehicleInspector.simple.color.prozent[3] = {154/255, 	205/255,  	 50/255,	1.00 }; --yellowGreen
	VehicleInspector.simple.color.prozent[4] = {255/255, 	255/255, 	  0/255, 	1.00 }; --yellow
	VehicleInspector.simple.color.prozent[5] = {255/255, 	 65/255, 	  0/255, 	1.00 }; --orange
	VehicleInspector.simple.color.prozent[6] = {255/255,  	 28/255,   	  0/255, 	1.00 }; --orangeRed
	VehicleInspector.simple.color.prozent[7] = {255/255,	  0/255, 	  0/255, 	1.00 }; --red	
	VehicleInspector.hlDebugMode = false;
	VehicleInspector.helpMenu = nil;
	VehicleInspector:getInGameDisplay();
	VehicleInspector:init();
	VehicleInspector:setGetCfg(true);	
end;

function VehicleInspector:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleInspector:setGetCfg(false);	
end;

function VehicleInspector:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleInspector:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleInspector.simple.rebootXml and Input.isKeyPressed(Input.KEY_esc) then
		if g_currentMission.inGameMenu.isOpen then VehicleInspector:setGetCfg(true);end;		
	end;
	if VehicleInspector.hlDebugMode and Input.isKeyPressed(Input.KEY_f2)then		
		if g_currentMission.hl.debug ~= nil then
			local a=1;		
			for key,value in pairs(g_currentMission.hl.debug) do
				for key1,value1 in pairs(value) do			
					print(tostring(a).. ".hl_Debug Error at ".. tostring(key).. " = ".. tostring(value1))			
					a=a+1;
				end;
			end;
		else
			print("1.hl_Debug NOT Found Error at ".. tostring(VehicleInspector.metadata.title))
		end;
	end;
end;

function VehicleInspector:update(dt)	
end;

function VehicleInspector:draw(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	if VehicleInspector.simple.isOn and not VehicleInspector:getFullSize() and not VehicleInspector:getIngameMap() then 
		local seeDrawSimple = VehicleInspector:setPosX_Y(VehicleInspector.simple.showMod.helpMenuOn, VehicleInspector.simple.showMod.helpMenuOff, g_gameSettings:getValue("showHelpMenu"));
		if VehicleInspector.simple.showMod.helpMenuOn and VehicleInspector.simple.showMod.helpMenuOff then 
			--VehicleInspector:setPosX_Y(true, true, g_gameSettings:getValue("showHelpMenu"));
			--seeDrawSimple = true;
		elseif VehicleInspector.simple.showMod.helpMenuOn then
			--VehicleInspector:setPosX_Y(true, false, g_gameSettings:getValue("showHelpMenu"));
			--seeDrawSimple = true;
		elseif 	VehicleInspector.simple.showMod.helpMenuOff then
			--VehicleInspector:setPosX_Y(false, true, g_gameSettings:getValue("showHelpMenu"));
			--seeDrawSimple = true;
		end;
		
		if seeDrawSimple then VehicleInspector:drawSimple();end;
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(VehicleInspector);

function VehicleInspector:setPosX_Y(helpMenuOn, helpMenuOff, isShowHelpMenu)	
	if (helpMenuOn and isShowHelpMenu) then		
		if VehicleInspector.simple.showMod.helpMenuOnAndInputEmpty and VehicleInspector.helpMenu ~= nil and VehicleInspector.helpMenu.numUsedEntries == 0 then return false;end;
		if not VehicleInspector.simple.ownPos.isOn and VehicleInspector.helpMenu ~= nil and VehicleInspector.helpMenu.overlay ~= nil then
			VehicleInspector.simple.defaultPosY = VehicleInspector.helpMenu.overlay.y;
		end;
		return true;	
	elseif helpMenuOff and not isShowHelpMenu then
		if (g_currentMission.vehicleFruitHud ~= nil and g_currentMission.vehicleFruitHud.schemaPos == 1) or g_currentMission.vehicleFruitHud == nil then
			if not VehicleInspector.simple.ownPos.isOn then VehicleInspector.simple.defaultPosY = VehicleInspector.simple.vehicleSchemaPosY;end;
		end;
		return true;
	elseif helpMenuOff and isShowHelpMenu and VehicleInspector.simple.showMod.helpMenuOffAndInputEmpty and VehicleInspector.helpMenu ~= nil and VehicleInspector.helpMenu.numUsedEntries == 0 then
		if not VehicleInspector.simple.ownPos.isOn then VehicleInspector.simple.defaultPosY = VehicleInspector.simple.vehicleSchemaPosY;end;
		return true;
	end;
	return false;
end;

function VehicleInspector:drawSimple()	
	local size = VehicleInspector.simple.defaultSize;
	local posX = VehicleInspector.simple.defaultPosX;
	local posY = VehicleInspector.simple.defaultPosY;
	if VehicleInspector.simple.ownPos.isOn then posX = VehicleInspector.simple.ownPos.x;posY = VehicleInspector.simple.ownPos.y;end;
	local lineDistancePosY = VehicleInspector.simple.lineDistancePosY;
	local lineNextTxtDistancePosX = VehicleInspector.simple.lineNextTxtDistancePosX;	
	--if g_gameSettings.ingameMapState == 0 then posX = 0.0;end; --LS19 render Error(see slide Effect HelpMenu)
	
	--local inVehicle, rootNode = g_currentMission.hl.isAvailable(g_currentMission.controlledVehicles, true);
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		local txtHeight = 0;		
		local outputStringLimit = 4;
		for a=1, #g_currentMission.vehicles do
			local vehicle = g_currentMission.vehicles[a];			
			if vehicle ~= nil and vehicle.getIsControlled ~= nil then --and vehicle.getCurrentHelper ~= nil then
				local txtWidth = 0;
				local separator = VehicleInspector.simple.txt.separator;
				local fillNameToFillLevel = VehicleInspector.simple.txt.fillNameToFillLevel;
				local helperS = VehicleInspector.simple.txt.helperS;
				local otherT = VehicleInspector.simple.txt.otherT;			
				local playerS = VehicleInspector.simple.txt.playerS;				
				local otherSaEmpty = VehicleInspector.simple.txt.otherSaEmpty;
				local otherSaOrFill = VehicleInspector.simple.txt.otherSaOrFill;
				local otherSa = VehicleInspector.simple.txt.otherSa;
				local otherW = VehicleInspector.simple.txt.otherW;
				local otherD = VehicleInspector.simple.txt.otherD;
				local otherB = VehicleInspector.simple.txt.otherB;
				local otherFuelEmpty = VehicleInspector.simple.txt.otherFuelEmpty;
				local otherFull = VehicleInspector.simple.txt.otherFull;
				local otherL = VehicleInspector.simple.txt.otherL;
				local horseHealthTxt = VehicleInspector.simple.txt.horseHealth;
				local horseFitnessTxt = VehicleInspector.simple.txt.horseFitness;
				local horseTodayRidingTxt = VehicleInspector.simple.txt.horseTodayRiding;
				local horseTodayRidingHourTxt = VehicleInspector.simple.txt.horseTodayRidingHour;
				local horseDayRidingTxt = VehicleInspector.simple.txt.horseDayRiding;
				local horseCareTxt = VehicleInspector.simple.txt.horseCare;
				local outputString = {};
				outputString[#outputString+1] = {};
				outputString[#outputString].txt = "";				
				if VehicleInspector.simple.seePlayerName and vehicle.getIsControlled(vehicle) then playerS = vehicle.getControllerName(vehicle);end;
				--check performens getIsInUse
				if vehicle.getIsControlled(vehicle) and g_gameSettings.nickname == vehicle.getControllerName(vehicle) then outputString[#outputString].txtBold = true;end;
				
				local seeLine = false;
				--later check and update
				--if VehicleInspector.simple.isFillFull and vehicle.getFillUnitFillLevelPercentage ~= nil and vehicle.getFillUnitFillLevelPercentage(vehicle) >= 100 then seeLine = true;outputString[#outputString].txt = otherS;end;
				--later check and update
				local foundHorse = vehicle.specializationsByName ~= nil and vehicle.specializationsByName.rideable ~= nil and vehicle.spec_rideable ~= nil and vehicle.spec_rideable.animal ~= nil;
				local trainFound = false;
				if VehicleInspector.simple.isTrain and ((vehicle.viVehicleName ~= nil and vehicle.viVehicleName == "Train") or vehicle.trainSystem ~= nil) then seeLine = true;trainFound=true;outputString[#outputString].txt = outputString[#outputString].txt.. otherT;end;
				if VehicleInspector.simple.isHelper and vehicle.getCurrentHelper ~= nil and vehicle.getCurrentHelper(vehicle) then seeLine = true;outputString[#outputString].txt = outputString[#outputString].txt.. helperS;end;
				if VehicleInspector.simple.isPlayer and vehicle.getIsControlled(vehicle) then 
					if not foundHorse or (foundHorse and VehicleInspector.simple.isHorsePlayer) then
						seeLine = true;
						if string.len(outputString[#outputString].txt) > 0 then outputString[#outputString].txt = outputString[#outputString].txt.. "+";end;
						outputString[#outputString].txt = outputString[#outputString].txt.. playerS;outputString[#outputString].txtColor = VehicleInspector.simple.color.playerControlled; 
						if VehicleInspector.simple.allTxtBold and g_gameSettings.nickname ~= vehicle.getControllerName(vehicle) then outputString[#outputString].txtColor = VehicleInspector.simple.color.anotherPlayerControlled;end;
					end;
				end;				 
				
				-------
				--if not trainFound and VehicleInspector.simple.ownFarmVehicle and FarmManager ~= nil then --FarmManager is LS Bug check before
				--	local playerFarm = FarmManager.getFarmByUserId(g_farmManager, g_currentMission.playerUserId)
				--	if playerFarm ~= nil and type(playerFarm) == "table" and vehicle.ownerFarmId ~= playerFarm.farmId then seeLine = false;end;					
				--end;
				if not trainFound and VehicleInspector.simple.ownFarmVehicle then --better not 100%					
					if g_currentMission.player.farmId ~= vehicle.ownerFarmId then seeLine = false;end;					
				end;
				-------
								
				if seeLine then					
					-----with horse see always Name
					if VehicleInspector.simple.seeVehicleName or VehicleInspector.simple.seeVehicleSmallName or VehicleInspector.simple.seeVehicleTypeName then
						outputString[#outputString+1] = {};
						VehicleInspector:setVehicleName(self, vehicle, false);					
						outputString[#outputString].txt = tostring(vehicle.viVehicleName);
						if VehicleInspector.simple.seeVehicleSmallName then outputString[#outputString].txt = tostring(vehicle.getName(vehicle));end;
						if VehicleInspector.simple.seeVehicleTypeName then outputString[#outputString].txt = tostring(vehicle.typeDesc);end;
						--local damageLevel = vehicle.getVehicleDamage(vehicle) later Update and Color
					end;					
					if foundHorse and Horse ~= nil then
						outputString[#outputString].txt = VehicleInspector.simple.txt.horse.. tostring(vehicle.getName(vehicle));
						if VehicleInspector.simple.seeHorseFitness then
							local fitnessScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getFitnessScale(vehicle.spec_rideable.animal)*100, 0));
							outputString[#outputString+1] = {};
							outputString[#outputString].txt = horseFitnessTxt.. tostring(fitnessScale).. "%";
							if VehicleInspector.simple.horseWarningColor then
								local isOkay, color = VehicleInspector:get_hl("getProzentColor", {fitnessScale, true}, "Horse Fitness Color"); --VehicleInspector:getProzentColor(fitnessScale, true)
								if not isOkay then color = 2;end;
								if color == 1 then color = 2;end;
								outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];
								if color == 7 then outputString[#outputString].txtBold = true;end;
							end;
						end;
						if VehicleInspector.simple.seeHorseHealth then
							local healthScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal)*100, 0));
							outputString[#outputString+1] = {};
							outputString[#outputString].txt = horseHealthTxt.. tostring(healthScale).. "%";
							if VehicleInspector.simple.horseWarningColor then
								local isOkay, color = VehicleInspector:get_hl("getProzentColor", {healthScale, true}, "Horse Health Color"); --VehicleInspector:getProzentColor(healthScale, true)
								if not isOkay then color = 2;end;
								if color == 1 then color = 2;end;
								outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];
								if color == 7 then outputString[#outputString].txtBold = true;end;
							end;
						end;
						if VehicleInspector.simple.seeHorseCare then							
							local careScale = g_i18n:formatNumber(Utils.getNoNil(100-(Horse.getDirtScale(vehicle.spec_rideable.animal)*100), 0));							
							outputString[#outputString+1] = {};
							outputString[#outputString].txt = horseCareTxt.. tostring(careScale).. "%";
							if VehicleInspector.simple.horseWarningColor then
								local color = VehicleInspector:getProzentColor(careScale, true)
								if color == 1 then color = 2;end;
								outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];
								if color == 7 then outputString[#outputString].txtBold = true;end;
							end;
						end;						
						if VehicleInspector.simple.seeHorseDayRiding then
							local dayRidingTimeTemp = Utils.getNoNil(vehicle.spec_rideable.animal.ridingTimer, 0);
							local dailyTarget = Utils.getNoNil(Horse.DAILY_TARGET_RIDING_TIME, 300000);
							local dayRidingTime = g_i18n:formatNumber((dayRidingTimeTemp/dailyTarget)*100);
							
							--local dayRidingTimer = VehicleInspector:getMilliSecondsToHours(dayRidingTimeTemp, VehicleInspector.simple.seeHorseTodayRidingMin, VehicleInspector.simple.seeHorseTodayRidingSec);
							outputString[#outputString+1] = {};
							outputString[#outputString].txt = horseDayRidingTxt.. tostring(dayRidingTime).. "%"; --/ ".. tostring(dayRidingTimer);
							if VehicleInspector.simple.horseWarningColor then
								local color = VehicleInspector:getProzentColor(dayRidingTime, true)
								if color == 1 then color = 2;end;
								outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];
								if color == 7 then outputString[#outputString].txtBold = true;end;
							end;
						end;
						if VehicleInspector.simple.seeHorseTodayRiding then
							local todaysRidingTimeTemp = Utils.getNoNil(Horse.getTodaysRidingTime(vehicle.spec_rideable.animal), 0);
							local todaysRidingTime = VehicleInspector:getMilliSecondsToHours(todaysRidingTimeTemp, VehicleInspector.simple.seeHorseTodayRidingMin, VehicleInspector.simple.seeHorseTodayRidingSec, horseTodayRidingHourTxt);
							outputString[#outputString+1] = {};
							outputString[#outputString].txt = horseTodayRidingTxt.. tostring(todaysRidingTime);
						end;
						
						--sellPrice unknown later new search 
						--local todaysRidingTimeTemp = Horse.getTodaysRidingTime(vehicle.spec_rideable.animal)
						--local todaysRidingTime = VehicleInspector:getMilliSecondsToHours(todaysRidingTimeTemp, true, true);
						--local todaysRidingTime = g_i18n:formatMinutes(todaysRidingTimeTemp)
						--local fitnessScale = string.format("%1.0f", "".. Utils.getNoNil(Horse.getFitnessScale(vehicle.spec_rideable.animal)*100, 0)).. "%"; --Horse.getFitnessScale(vehicle.spec_rideable.animal)*100
						--local healthScale = string.format("%1.1f", "".. Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal)*100, 0)).. "%";
						--local healthScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal)*100, 0));
						
						--string.format("%1.0f", "".. Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal)*100, 0));
						--oder getValueScale() testen
						--local sellPrice = g_i18n:formatMoney(vehicle.getSellPrice(vehicle)) --gibt 7 statt 2.975						
						--local sellPrice = vehicle.getSellPrice(vehicle) --gibt 7 statt 2.975
						--local sellPriceTemp = Horse.getValueScale(vehicle.spec_rideable.animal)
						--local difficultyMultiplier = EconomyManager.getPriceMultiplier() --math.max(2 * (3 - g_currentMission.missionInfo.difficulty), 1)
						--local sellPrice = g_i18n:formatMoney(vehicle.getSellPrice(vehicle)*sellPriceTemp*difficultyMultiplier*100);
						--renderText(0.5, 0.24, 0.010, "Total geritten_ ".. tostring(todaysRidingTime).. "   Fitness_ ".. tostring(fitnessScale));
						--renderText(0.5, 0.22, 0.010, "Health_ ".. tostring(healthScale).. "   SellPrice_ ".. tostring(sellPrice));
						--renderText(0.5, 0.21, 0.010, "Multiplier_ ".. tostring(difficultyMultiplier));
						--sellPrice unknown later new search
					end;
					-----with horse always Name
					if VehicleInspector.simple.isLeasing and not VehicleInspector.simple.leasingTxtLast and vehicle.propertyState == 2 and string.len(otherL) > 0 then --first Leasing
						table.insert(outputString, 1, {});											
						outputString[1].txt = tostring(otherL);
						outputString[1].txtColor = VehicleInspector.simple.color.isLeasing;
					end;
					
					if VehicleInspector.simple.seeField and vehicle.trainSystem == nil then
						local field = 0;
						--if vehicle.getIsOnField(vehicle) then field = VehicleInspector:getIsOnField(vehicle);end;
						if vehicle.getIsOnField(vehicle) then 
							field = VehicleInspector:getIsOnField(vehicle);
							outputString[1].txtBold = true;
							outputString[1].txtColor = VehicleInspector.simple.color.isField;
						end;
						outputString[1].txt = tostring(VehicleInspector.simple.txt.field); --.. tostring(field);						
					end;
					if VehicleInspector.simple.seeSpeed then
						table.insert(outputString, 1, {});						
						outputString[1].txt = VehicleInspector:getSpeed(vehicle).. tostring(VehicleInspector.simple.txt.speed);
					end;					
					if vehicle.trainSystem == nil and VehicleInspector.simple.isWater and vehicle.showTailwaterDepthWarning then
						table.insert(outputString, 1, {});
						outputString[1].txt = otherW;
						outputString[1].txtColor = VehicleInspector.simple.color.isWater;
						outputString[1].txtBold = true;
					end;
					if vehicle.trainSystem == nil and VehicleInspector.simple.isDamage and vehicle.isBroken then
						table.insert(outputString, 1, {});
						outputString[1].txt = otherD;
						outputString[1].txtColor = VehicleInspector.simple.color.isDamage;
						outputString[1].txtBold = true;
					end;
					
					--MP check Server and send event for Blocking etc. !!
					--vehicle.spec_aiVehicle
					--aiTrafficCollisionTranslation
					--aiTrafficCollision
					--debugTexts
					if VehicleInspector.simple.isBlocking and not vehicle.showTailwaterDepthWarning and vehicle.spec_aiVehicle ~= nil and vehicle.spec_aiVehicle.debugTexts ~= nil then							
						if vehicle.spec_aiVehicle.debugTexts[1] ~= nil and string.find(vehicle.spec_aiVehicle.debugTexts[1], "STOP") and string.find(vehicle.spec_aiVehicle.debugTexts[1], "collision") then		
							table.insert(outputString, 1, {});
							outputString[1].txt = otherB;
							outputString[1].txtColor = VehicleInspector.simple.color.isBlocking;
							outputString[1].txtBold = true;	
						end;						
					end;					
					local attach, attachedSprayerAnd = VehicleInspector:getAttachedAndSprayerAnd(vehicle, 1);
					if not foundHorse then
						local fillLevelTable = {};
						if vehicle.getFillLevelInformation ~= nil then
							vehicle:getFillLevelInformation(fillLevelTable);
							for _,fillLevelVehicle in pairs(fillLevelTable) do
								if fillLevelVehicle.fillLevel > 0 then
									outputString[#outputString+1] = {};
									local typeName = Utils.getNoNil(string.lower(vehicle.typeName), "Unknown");
									local invertProzent = VehicleInspector:isInvertFill(typeName) or (attachedSprayerAnd > 0 and attach == 1) or (attachedSprayerAnd == attach);--string.find(typeName, "sowing") or string.find(typeName, "sprayer") or string.find(typeName, "manure") or string.find(typeName, "fertilizer") or attachedSprayerAnd > 0;
									if VehicleInspector.simple.seeFillLevel then
										outputString[#outputString].txt = string.format("%1.0f", Utils.getNoNil(fillLevelVehicle.fillLevel, 0));									
										if fillLevelVehicle.capacity > 0 then
											if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then --Unknown Seeds or Fill etc.
												local prozent = VehicleInspector:getProzentString(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, true);
												local color = VehicleInspector:getProzentColor(prozent,invertProzent);
												outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];
												if color == 7 then
													table.insert(outputString, 1, {});
													outputString[1].txt = otherFull;
													if invertProzent then outputString[1].txt = otherSaEmpty;end;
													outputString[1].txtColor = VehicleInspector.simple.color.prozent[color]; --Full or Empty
													outputString[1].txtBold = true;
												end;
											end;
										end;
									end;
									if VehicleInspector.simple.seeProzent and fillLevelVehicle.capacity > 0 then
										local prozent = VehicleInspector:getProzentString(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, false);
										if not VehicleInspector.simple.seeFillLevel then 
											outputString[#outputString].txt = tostring(prozent).. "%";										
											if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then --Unknown Seeds or Fill etc.
												local color = VehicleInspector:getProzentColor(prozent,invertProzent);												
												outputString[#outputString].txtColor = VehicleInspector.simple.color.prozent[color];												
												if color == 7 and not VehicleInspector.simple.seeFillLevel then
													table.insert(outputString, 1, {});
													outputString[1].txt = otherFull;
													if invertProzent then outputString[1].txt = otherSaEmpty;end;
													outputString[1].txtColor = VehicleInspector.simple.color.prozent[color]; --Full oder Empty
													outputString[1].txtBold = true;
												end;										
											end;
										else
											outputString[#outputString].txt = outputString[#outputString].txt.. " (".. tostring(prozent).. "%)";
										end;
									end;
									if VehicleInspector.simple.seeFillName then
										local newString = outputString[#outputString].txt;										
										local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillLevelVehicle.fillType);
										if not VehicleInspector.simple.seeRealFillName then local fillTypeNameTemp = g_fillTypeManager.nameToFillType[fillTypeName].title;fillTypeName = fillTypeNameTemp;end;
										outputString[#outputString].txt = tostring(fillTypeName).. fillNameToFillLevel.. newString;
									end;
									if invertProzent or attachedSprayerAnd > 0 then								
										local newString = outputString[#outputString].txt
										if (attachedSprayerAnd <= 1 and attach == 1) or (attachedSprayerAnd == attach) then
											outputString[#outputString].txt = otherSa.. newString;
										else
											outputString[#outputString].txt = otherSaOrFill.. newString;
										end;
									end;
								end;
							end;						
						end;
					end;
					if VehicleInspector.simple.isLeasing and VehicleInspector.simple.leasingTxtLast and vehicle.propertyState == 2 and string.len(otherL) > 0 then --first Leasing
						outputString[#outputString+1] = {};											
						outputString[#outputString].txt = tostring(otherL);
						outputString[#outputString].txtColor = VehicleInspector.simple.color.isLeasing;
					end;
					if attach > 0 and VehicleInspector.simple.seeLastTotalAttached then
						outputString[#outputString+1] = {};											
						outputString[#outputString].txt = tonumber(attach);					
					end;								
				end;
				local newHeight = true;
				if seeLine then
					for b=1, #outputString do
						if outputString[b] ~= nil and string.len(outputString[b].txt) > 0 then
							if newHeight then txtHeight = txtHeight+getTextHeight(size, tostring(outputString[b].txt).. separator)+lineDistancePosY;newHeight = false;end;
							setTextColor(unpack(VehicleInspector.simple.color.default));							
							setTextBold(VehicleInspector.simple.allTxtBold);
							if outputString[b].txtColor ~= nil then setTextColor(unpack(outputString[b].txtColor));end;
							if outputString[b].txtBold ~= nil then setTextBold(outputString[b].txtBold);end;
							renderText(posX+txtWidth, posY-txtHeight, size, tostring(outputString[b].txt));						
							txtWidth = txtWidth+lineNextTxtDistancePosX+getTextWidth(size, tostring(outputString[b].txt));
							--separator
							setTextColor(unpack(VehicleInspector.simple.color.default));							
							setTextBold(VehicleInspector.simple.allTxtBold);
							renderText(posX+txtWidth, posY-txtHeight, size, separator);
							txtWidth = txtWidth+lineNextTxtDistancePosX+getTextWidth(size, separator);
							--separator
						end;
					end;
				end;
			end;
		end;
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;

function VehicleInspector:getProzentColor(prozent,invert, whoTrigger)
	local isOkay, color = VehicleInspector:get_hl("getProzentColor", {prozent,invert}, whoTrigger); --pcall(g_currentMission.hl.getProzentColor, prozent, invert);	
	if isOkay then return color;else return 1;end;	
end;

function VehicleInspector:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if VehicleInspector.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if VehicleInspector.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if VehicleInspector.hlDebugMode and (not isOkay or foundArgsError) then VehicleInspector:setDebug("VehicleInspectorMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return isOkay, result;	
end;

function VehicleInspector:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function VehicleInspector:isInvertFill(typeName)
	for key,value in pairs(VehicleInspector.simple.searchInvert) do
		if string.find(VehicleInspector.simple.searchInvert[key], typeName) and string.len(typeName) == string.len(VehicleInspector.simple.searchInvert[key]) then return true;end;		
	end;
	return false;
end;

function VehicleInspector:getProzentString(fill, capacity, aNumber)	
	if not aNumber then
		return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
	else
		return fill/capacity*100;
	end;
end;

function VehicleInspector:getSpeed(vehicle)
	local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600; --lastSpeed,speedDisplayDt	
	if g_gameSettings:getValue('useMiles') then speed = Utils.getNoNil(vehicle.lastSpeed, 0)*0.62;end;
	if vehicle.viVehicleName == "Train" or vehicle.trainSystem ~= nil then speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3.6;end;
	return string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
end;

function VehicleInspector:getIsOnField(vehicle)
    local wx,wy,wz = getWorldTranslation(vehicle.components[1].node);
    local densityBits = getDensityAtWorldPos(g_currentMission.terrainDetailId, wx, wy, wz);
    return densityBits, densityBits ~= 0;
end;

function VehicleInspector:getAttachedAndSprayerAnd(vehicle, attachedLimit)	
	local attached = 0;
	local attachedSprayerAnd = 0;
	if vehicle.getAttachedImplements ~= nil then 
		local attachTable = vehicle.getAttachedImplements(vehicle);
		if attachTable ~= nil and attachedLimit <= VehicleInspector.simple.attachedLimit then		
			for _,attach in pairs(attachTable) do		
				if attach.object ~= nil and attach.object.typeName ~= nil then
					local typeName = Utils.getNoNil(string.lower(attach.object.typeName), "Unknown");
					if not string.find(typeName, "implements") and not string.find(typeName, "Unknown") then
						attached = attached+1;
					end;					
					if VehicleInspector:isInvertFill(typeName) then 
						attachedSprayerAnd = attachedSprayerAnd+1;
					end;
					local tempAttached, tempAttachedSprayerAnd = VehicleInspector:getAttachedAndSprayerAnd(attach.object, attachedLimit+1);
					attached = attached+tempAttached;
					attachedSprayerAnd = attachedSprayerAnd+tempAttachedSprayerAnd;
				end;
			end;
		end;
	end;
	return attached, attachedSprayerAnd;
end;

--VI LS17 Script, later new
function VehicleInspector:setVehicleName(self, vehicle, attachable)
	local vehicleName = "Unknown";
	local category = "Unknown";
	function setAlternativeName()
		if vehicle.baleWidth ~= nil then
			vehicle.viVehicleName = "Bale";
			vehicleName = "Bale";
		elseif vehicle.fillablePalletDirtyFlag ~= nil then
			vehicle.viVehicleName = "Pal.";
			vehicleName = "Pal.";
		end;
	end;
	--vehicle.getFullName(vehicle) okay return New Holland Tx 32
	--vehicle.getName(vehicle) okay return Tx32
	--!! not all vehicle.fullViewName = Combine
	--controlGroupNames --a table
	--vehicle.getControllerName(vehicle) okay return your User name
	--className = Vehicle
	--name = combineDrivable
	--nicknameRendering --a table
	--vehicle.typeName = 
	--vehicle.typeDesc = 
	
	--g_currentMission.vehicles.getIsVehicleControlledByPlayer()
	--getIsControlled()
	--getControllerName()
	--getFillUnitFillLevelPercentage()
	--getFillLevelInformation()
	
	if vehicle.configFileName == nil then 
		setAlternativeName();
		vehicle.viVehicleName = vehicleName;
		return;
	end;
	if vehicle.viVehicleName ~= nil then return;end;
	--local storeItem = StoreItemsUtil.storeItemsByXMLFilename[Utils.getNoNil(vehicle.configFileName, vehicle.xmlFilename):lower()];
    --if storeItem ~= nil then
    --    if storeItem.name ~= nil then
    --        vehicleName = tostring(storeItem.name);
    --    end;
        --if storeItem.category ~= nil and storeItem.category ~= "" then
        --    category = tostring(storeItem.category);
        --end;	
	--end;		
	
	vehicleName = tostring(vehicle.getFullName(vehicle));
	
	--local vehicleXml = loadXMLFile("MultiOverlayV2_XML", vehicle.configFileName, "vehicle");
	if vehicle.configFileName ~= nil then
		if string.find(tostring(vehicle.configFileName), "locomotive") then
			vehicleName = "Train";		
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "horse") then
			vehicleName = "Horse";
		elseif string.find(tostring(vehicle.configFileName), "stationCrane") then
			vehicleName = "Crane";
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "wagon") then
			vehicleName = "WagonFill";
			if string.find(tostring(vehicle.configFileName:lower()), "timber") then
				vehicleName = "WagonTimber";
			end;
			if attachable then vehicle.typeDesc = vehicleName;end;
		elseif string.find(tostring(vehicle.configFileName), "ka26") then
			vehicleName = "Heli";
			if not attachable then vehicle.typeDesc = vehicleName;end;
		elseif vehicle.time ~= nil and vehicle.time > 0 then
			vehicleName = vehicleName.. "-Missions Vehicle";
		end;
	end;
	if vehicleName == "Unknown" then setAlternativeName();end;
	--tableVehicle.name = vehicleName;	
	vehicle.viVehicleName = vehicleName;
end;

function VehicleInspector:init()
	source(VehicleInspector.modDir.."_hl.lua");
end;

function VehicleInspector:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec, endString)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == nil or nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", math.floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", math.floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", math.floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours.. tostring(endString);end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

function VehicleInspector:stringSplit(txtString,delimiter)
	local isOkay, result = pcall(g_currentMission.hl.stringSplit, txtString, delimiter);
	if okay then return result;else return {};end;	
end;

function VehicleInspector:getFullSize()
	if g_currentMission.paused or
	g_currentMission.inGameMenu.paused or	
	g_currentMission.inGameMenu.isOpen or 
	g_currentMission.physicsPaused then
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end;
	return true;end;
	return false;
end;

function VehicleInspector:getInGameDisplay()
	if g_currentMission.hud.inputHelp.controlsLabelText ~= nil and g_currentMission.hud.inputHelp.numUsedEntries ~= nil then
		VehicleInspector.helpMenu = g_currentMission.hud.inputHelp;
		return;
	end;
	for key, value in pairs(g_currentMission.hud.displayComponents) do
		if g_currentMission.hud.displayComponents[key].controlsLabelText ~= nil and g_currentMission.hud.displayComponents[key].numUsedEntries ~= nil then
			VehicleInspector.helpMenu = g_currentMission.hud.displayComponents[key];
			break;
		end;
	end;
end;

function VehicleInspector:getIngameMap()
	return g_gameSettings:getValue("ingameMapState") == 1;	
end;

function VehicleInspector:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";
	local Xml = nil;
	local xmlVersion = 0.2;
	if not fileExists(file) or not loadCfg then		
		Xml = createXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		local groupNameTag = ("vehicleInspectorSettings.simple.version(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#xmlVersion", tostring(xmlVersion));
		local groupNameTag = ("vehicleInspectorSettings.simple.global(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#isOn", VehicleInspector.simple.isOn);
		setXMLFloat(Xml, groupNameTag.. "#posX", VehicleInspector.simple.defaultPosX);
		setXMLFloat(Xml, groupNameTag.. "#posY", VehicleInspector.simple.defaultPosY);
		setXMLBool(Xml, groupNameTag.. "#rebootXmlESC", VehicleInspector.simple.rebootXml);		
		
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOn_F1(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.helpMenuOn);
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOnAndInputEmpty(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.helpMenuOnAndInputEmpty);
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOff_F1(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.helpMenuOff);
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOffAndInputEmpty(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.helpMenuOffAndInputEmpty);
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isInGameMapOn(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.inGameMapOn);
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isInGameMapOff(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.showMod.inGameMapOff);
		
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.txtSize(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.simple.defaultSize);
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.txtAllBold(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.allTxtBold);
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.leasingTxtLast(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.leasingTxtLast);
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.attachedLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.attachedLimit);		
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.lineNextTxtDistancePosX(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.simple.lineNextTxtDistancePosX);
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.lineDistancePosY(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.simple.lineDistancePosY);
		local searchInvertTemp = ""
		for key,value in pairs(VehicleInspector.simple.searchInvert) do
			if string.len(searchInvertTemp) > 0 then searchInvertTemp = searchInvertTemp.. ",".. tostring(VehicleInspector.simple.searchInvert[key])
			else searchInvertTemp = searchInvertTemp.. tostring(VehicleInspector.simple.searchInvert[key]);end;
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.searchInvertColorByVehicleTypeName(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#stringWithCommaseparator", tostring(searchInvertTemp));
		
		
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isFillFull(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isFillFull);
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isTrain(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isTrain);
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isPlayer(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isPlayer);
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isHorsePlayer(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isHorsePlayer);
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isHelper(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isHelper);
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.ownFarmVehicle(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.ownFarmVehicle);
		
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeField(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeField);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeSpeed(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeSpeed);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeFillName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeFillName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeFillName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeFillName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeRealFillName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeRealFillName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeFillLevel(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeFillLevel);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeProzent(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeProzent);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seePlayerName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seePlayerName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeVehicleName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleSmallName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeVehicleSmallName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleTypeName(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeVehicleTypeName);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeLastTotalAttached(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeLastTotalAttached);
		
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isFuel(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isFuel);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isBlocking(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isBlocking);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isDamage(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isDamage);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isWater(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isWater);
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isLeasing(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.isLeasing);
						
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.defaultseparator(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.separator);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.fillNameToFillLevelseparator(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.fillNameToFillLevel);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSpeed(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.speed);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isField(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.field);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isHorse(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horse);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isTrain(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherT);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isHelper(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.helperS);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isPlayer(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.playerS);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeeds(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherSa);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeedsEmpty(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherSaEmpty);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeedsOrFill(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherSaOrFill);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isWater(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherW);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isDamage(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherD);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isBlocking(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherB);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isLeasing(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherL);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isFull(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherFull);
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isFuelEmty(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.otherFuelEmpty);
				
		groupNameTag = ("vehicleInspectorSettings.simple.horse.horseTxtWarningColor(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.horseWarningColor);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseHealth(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseHealth);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.healthTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseHealth);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseFitness(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseFitness);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.fitnessTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseFitness);		
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseCare(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseCare);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.careTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseCare);		
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseTodayRiding(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseTodayRiding);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.todayRidingTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseTodayRiding);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseTodayRidingMin(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseTodayRidingMin);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseTodayRidingSec(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseTodayRidingSec);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.todayRidingHourTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseTodayRidingHour);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseDayRiding(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.seeHorseDayRiding);
		groupNameTag = ("vehicleInspectorSettings.simple.horse.dayRidingTxt(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#txt", VehicleInspector.simple.txt.horseDayRiding);
				
		groupNameTag = ("vehicleInspectorSettings.simple.colors.defaultTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.default[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.default[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.default[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.default[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_0-24Fill(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[1][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[1][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[1][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[1][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_76-100Seeds(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[2][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[2][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[2][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[2][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_25-49(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[3][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[3][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[3][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[3][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_50-74(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[4][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[4][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[4][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[4][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_75-94(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[5][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[5][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[5][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[5][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_95-99(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[6][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[6][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[6][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[6][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_100(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.prozent[7][1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.prozent[7][2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.prozent[7][3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.prozent[7][4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.playerControlled(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.playerControlled[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.playerControlled[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.playerControlled[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.playerControlled[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.anotherPlayerControlled(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.anotherPlayerControlled[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.anotherPlayerControlled[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.anotherPlayerControlled[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.anotherPlayerControlled[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isFieldTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.isField[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.isField[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.isField[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.isField[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isWaterTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.isWater[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.isWater[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.isWater[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.isWater[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isDamageTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.isDamage[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.isDamage[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.isDamage[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.isDamage[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isBlockingTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.isBlocking[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.isBlocking[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.isBlocking[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.isBlocking[4]);
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isLeasingTxt(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#red", VehicleInspector.simple.color.isLeasing[1]);setXMLFloat(Xml, groupNameTag.. "#green", VehicleInspector.simple.color.isLeasing[2]);setXMLFloat(Xml, groupNameTag.. "#blue", VehicleInspector.simple.color.isLeasing[3]);setXMLFloat(Xml, groupNameTag.. "#alpha", VehicleInspector.simple.color.isLeasing[4]);
		
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.attention(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#info", "!! Mod check not up/down/left/right correct Display Position/lenght/width/height (helpMeneOn/Off etc. is active) !! Wait next Update for more");
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.isOn(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.simple.ownPos.isOn);
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.posX(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.simple.ownPos.x);
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.posY(%d)"):format(0);
		setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.simple.ownPos.y);
		
		saveXMLFile(Xml);
	else
		Xml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		local groupNameTag = ("vehicleInspectorSettings.simple.version(%d)"):format(0);
		if not getXMLString(Xml, groupNameTag.. "#xmlVersion") then VehicleInspector:saveOldXml();VehicleInspector:setGetCfg(false)return;end;
		local xmlVersionTemp = string.format("%1.1f", "".. getXMLString(Xml, groupNameTag.. "#xmlVersion"));		
		if tonumber(xmlVersionTemp) < tonumber(xmlVersion) then VehicleInspector:saveOldXml();VehicleInspector:setGetCfg(false)return;end;
		
		local groupNameTag = ("vehicleInspectorSettings.simple.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#isOn") ~= nil then VehicleInspector.simple.isOn = getXMLBool(Xml, groupNameTag.. "#isOn");end;
		if getXMLBool(Xml, groupNameTag.. "#rebootXmlESC") ~= nil then VehicleInspector.simple.rebootXml = getXMLBool(Xml, groupNameTag.. "#rebootXmlESC");end;		
		if getXMLFloat(Xml, groupNameTag.. "#posX") then VehicleInspector.simple.defaultPosX = getXMLFloat(Xml, groupNameTag.. "#posX");end;
		if getXMLFloat(Xml, groupNameTag.. "#posY") then VehicleInspector.simple.defaultPosY = getXMLFloat(Xml, groupNameTag.. "#posY");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOn_F1(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.helpMenuOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOnAndInputEmpty(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.helpMenuOnAndInputEmpty = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOff_F1(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.helpMenuOff = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isHelpMenuOffAndInputEmpty(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.helpMenuOffAndInputEmpty = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isInGameMapOn(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.inGameMapOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showMod.isInGameMapOff(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.showMod.inGameMapOff = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.txtSize(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") ~= nil then VehicleInspector.simple.defaultSize = getXMLFloat(Xml, groupNameTag.. "#float");end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.txtAllBold(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.allTxtBold = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.leasingTxtLast(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.leasingTxtLast = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.lineNextTxtDistancePosX(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.simple.lineNextTxtDistancePosX = getXMLFloat(Xml, groupNameTag.. "#float");end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.lineDistancePosY(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.simple.lineDistancePosY = getXMLFloat(Xml, groupNameTag.. "#float");end;
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.attachedLimit(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#boolean") then VehicleInspector.simple.attachedLimit = getXMLInt(Xml, groupNameTag.. "#boolean");end;
		
		--check is old or new xml structure v1.43, later remove
		local searchInvertTemp = "";		
		groupNameTag = ("vehicleInspectorSettings.simple.otherValues.searchInvertColorByVehicleTypeName(%d)"):format(0);
		local groupNameTagOld = ("vehicleInspectorSettings.simple.other(%d)"):format(0);
		if groupNameTagOld ~= nil and getXMLString(Xml, groupNameTagOld.. "#searchInvert") ~= nil then searchInvertTemp = getXMLString(Xml, groupNameTagOld.. "#searchInvert");		
		elseif getXMLString(Xml, groupNameTag.. "#stringWithCommaseparator") ~= nil then searchInvertTemp = getXMLString(Xml, groupNameTag.. "#stringWithCommaseparator");end;
		local stringSplit = VehicleInspector:stringSplit(searchInvertTemp, ",");
		if stringSplit ~= nil and #stringSplit > 0 then
			searchInvertTemp = ",";			
			VehicleInspector.simple.searchInvert = {};
			for key,value in pairs(stringSplit) do				
				if VehicleInspector.simple.searchInvert[key] == nil then table.insert(VehicleInspector.simple.searchInvert, tostring(string.lower(stringSplit[key])));end;
				searchInvertTemp = searchInvertTemp.. tostring(string.lower(stringSplit[key])).. ",";
			end;			
		end;

		
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isFillFull(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isFillFull = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isTrain(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isTrain = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isPlayer(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isPlayer = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isHorsePlayer(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isHorsePlayer = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.isHelper(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isHelper = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showVehicle.ownFarmVehicle(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.ownFarmVehicle = getXMLBool(Xml, groupNameTag.. "#boolean");end;
				
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeField(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeField = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeSpeed(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeSpeed = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeFillName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeFillName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeRealFillName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeRealFillName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeProzent(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeProzent = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seePlayerName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seePlayerName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeVehicleName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleSmallName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeVehicleSmallName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeVehicleTypeName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeVehicleTypeName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.seeLastTotalAttached(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeLastTotalAttached = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isBlocking(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isBlocking = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isDamage(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isDamage = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isWater(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isWater = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isFuel(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isFuel = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.showTxtOr.isLeasing(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.isLeasing = getXMLBool(Xml, groupNameTag.. "#boolean");end;
								
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.defaultseparator(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.separator = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.fillNameToFillLevelseparator(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.fillNameToFillLevel = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSpeed(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.speed = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isField(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.field = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isHorse(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horse = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isTrain(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherT = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isHelper(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.helperS = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isPlayer(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.playerS = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeeds(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherSa = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeedsEmpty(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherSaEmpty = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isSeedsOrFill(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherSaOrFill = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isWater(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherW = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isDamage(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherD = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isBlocking(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherB = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isLeasing(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherL = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isFull(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherFull = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.separatorAndTxt.isFuelEmty(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.otherFuelEmpty = getXMLString(Xml, groupNameTag.. "#txt");end;		
		
		groupNameTag = ("vehicleInspectorSettings.simple.horse.horseTxtWarningColor(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.horseWarningColor = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseHealth(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeHorseHealth = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.healthTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseHealth = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseFitness(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeHorseFitness = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.fitnessTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseFitness = getXMLString(Xml, groupNameTag.. "#txt");end;		
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseCare(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeHorseCare = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.careTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseCare = getXMLString(Xml, groupNameTag.. "#txt");end;		
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseTodayRiding(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeHorseTodayRiding = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.todayRidingTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseTodayRiding = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.todayRidingHourTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseTodayRidingHour = getXMLString(Xml, groupNameTag.. "#txt");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.seeHorseDayRiding(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.seeHorseDayRiding = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.horse.dayRidingTxt(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#txt") ~= nil then VehicleInspector.simple.txt.horseDayRiding = getXMLString(Xml, groupNameTag.. "#txt");end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.colors.defaultTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.default = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_0-24Fill(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[1] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_76-100Seeds(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[2] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_25-49(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[3] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_50-74(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[4] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_75-94(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[5] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_95-99(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[6] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.prozent_100(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.prozent[7] = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;		
		groupNameTag = ("vehicleInspectorSettings.simple.colors.playerControlled(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.playerControlled = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.anotherPlayerControlled(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.anotherPlayerControlled = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isFieldTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.isField = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isWaterTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.isWater = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isDamageTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.isDamage = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isBlockingTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.isBlocking = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		groupNameTag = ("vehicleInspectorSettings.simple.colors.isLeasingTxt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#red") and getXMLFloat(Xml, groupNameTag.. "#green") and getXMLFloat(Xml, groupNameTag.. "#blue") and getXMLFloat(Xml, groupNameTag.. "#alpha") then 
			VehicleInspector.simple.color.isLeasing = {getXMLFloat(Xml, groupNameTag.. "#red"),getXMLFloat(Xml, groupNameTag.. "#green"),getXMLFloat(Xml, groupNameTag.. "#blue"),getXMLFloat(Xml, groupNameTag.. "#alpha")};
		end;
		
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.isOn(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.simple.ownPos.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.posX(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.simple.ownPos.x = getXMLFloat(Xml, groupNameTag.. "#float");end;
		groupNameTag = ("vehicleInspectorSettings.simple.ownPosition.posY(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.simple.ownPos.y = getXMLFloat(Xml, groupNameTag.. "#float");end;
	end;
end;

function VehicleInspector:saveOldXml()	
	local getDateString = tostring(getDate("%d").. "_".. getDate("%w").. "_".. getDate("%m").. "_".. getDate("%Y"));
	local oldXml = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";	
	local backupXml = VehicleInspector.settingsDir.. "vehicleInspectorSettings_Old_Backup_".. getDateString.. ".xml";	
	copyFile(oldXml, backupXml, false);
end;